### R code from vignette source '01.Rnw'

###################################################
### code chunk number 1: c0
###################################################
suppressPackageStartupMessages(require(SOAR))
options(width=75)
graphics.off()
pdf(file="Fig/01_All.pdf", onefile=TRUE)
if(length(ls() > 0)) Store(ls())
options(continue="  ",
        SweaveHooks = list(fig = function() par(las = 1,
        family = "mono")))
## Sys.setenv(R_LOCAL_CACHE=".R_Store")
Attach()


###################################################
### code chunk number 2: c01
###################################################
rm(list = ls())
library(SOAR)
set.seed(1234)
x <- sort(runif(500, 0, 10))
beta <- runif(5, -1, 1)
eta <- cbind(1, poly(x, 4)) %*% beta
y <- exp(eta + rnorm(500, 0, 0.1))
mu <- exp(eta + 0.1^2/2)
dummyData <- data.frame(x=x, mu=mu, y=y, eta=eta)
Store(dummyData)
ls()
Ls()


###################################################
### code chunk number 3: c02
###################################################
library(SOAR)
rm(list = ls())
set.seed(1234)
dummyData <- within(data.frame(x = sort(runif(500, 0, 10))), {
  beta <- runif(5, -1, 1)
  eta <- cbind(1, poly(x, 4)) %*% beta
  y <- exp(eta + rnorm(500, 0, 0.1))
  mu <- exp(eta + 0.1^2/2)
  rm(beta)
})
Store(dummyData)
ls()
head(dummyData, 2)


###################################################
### code chunk number 4: c03
###################################################
plot(y ~ x, dummyData, pch=20, col="red")
lines(mu ~ x, dummyData, col="blue")
lines(exp(eta) ~ x, dummyData, col="darkgreen", lty="dashed")


###################################################
### code chunk number 5: c04
###################################################
attach(dummyData)
beta <- coef(lm(eta ~ poly(x, 4)))    ## OK so far
LModel <- lm(log(y) ~ poly(x, 4))     ## object incomplete
rbind(beta = beta, beta_hat = coef(LModel))


###################################################
### code chunk number 6: c06
###################################################
rough_1 <- lm(log(dummyData$y) ~ poly(dummyData$x, 4))    ## BAD!
rough_2 <- lm(log(dummyData[,3]) ~ poly(dummyData[,1],4)) ## Horrible!


###################################################
### code chunk number 7: c05
###################################################
beta <- with(dummyData,
             qr.coef(qr(cbind(1, poly(x, 4))), eta))
LModel <- lm(log(y) ~ poly(x, 4), dummyData)
rbind(beta = as.vector(beta), beta_hat = coef(LModel))


###################################################
### code chunk number 8: c07
###################################################
Search()  ## From the SOAR package - enhanced
detach("dummyData")


###################################################
### code chunk number 9: c08
###################################################
ci <- confint(LModel)
data.frame(ci, beta = beta,
           OK = ifelse(ci[, 1] < beta & beta < ci[,2], "yes", "no"),
           check.names = FALSE)


###################################################
### code chunk number 10: 01.Rnw:358-360
###################################################
toLatex(sessionInfo())
graphics.off()


